﻿using GTA; // This is a reference that is needed! do not edit this
using GTA.Native; // This is a reference that is needed! do not edit this
using GTA.Math;
using System; // This is a reference that is needed! do not edit this
using System.Windows.Forms; // This is a reference that is needed! do not edit this
using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace TruenoHeadlights
{
    public class TruenoHeadlights : Script // declare Modname as a script
    {
        //Automatic Pop-up Headlights for various add-on vehicles 3.4

        List<string> BackLeftDoorVehicles = new List<string> { };

        List<string> BackRightDoorVehicles = new List<string> { };

        List<string> HoodDoorVehicles = new List<string> { };

        List<string> TrunkDoorVehicles = new List<string> { };

        List<string> FrontLeftDoorVehicles = new List<string> { };

        List<string> FrontRightDoorVehicles = new List<string> { };

        List<string> ScoopVehicles = new List<string> { };

        List<string> ReverseLightsVehicles = new List<string> { "240sxbn", "rx7" };

        int DoorIndex = 2;
        /*
            doorIndex:
            0 = Front Left Door (driver door)
            1 = Front Right Door
            2 = Back Left Door
            3 = Back Right Door
            4 = Hood
            5 = Trunk
            6 = Trunk2
        */
        VehicleDoor CivHeadlights;
        Vehicle veh;
        Vehicle lastVeh;
        Vehicle[] allVeh;
        bool PedVehiclesAlso;
        bool LightsAutoON;
        bool LightsAutoOFF;
        int referenceTime = Game.GameTime;
        float doorSpeed;
        float staticAngle;
        float angle;
        float DoorCurrentAngle;
        int doorTimer;
        int doorSeconds = 4000;
        bool OpenDoorNOW;
        bool scoopIsUP = true;
        float scoopSpeed;
        float scoopSpeedKeyboard;
        int scoopTimer;
        int scoopSeconds = 2;

        Keys ScoopUP;
        Keys ScoopDOWN;

        public TruenoHeadlights() // main function
        {
            INISettings();
            ReadVehicles();
            //WriteTest();
            Tick += OnTick;
            Interval = 1;
        }

        void INISettings()
        {
            ScriptSettings config = ScriptSettings.Load(@"scripts\PopupHeadlights\Settings.ini");

            LightsAutoON = config.GetValue<bool>("Global Settings", "Auto Popups UP if vehicle lights are on", false);
            LightsAutoOFF = config.GetValue<bool>("Global Settings", "Auto Popups DOWN if vehicle lights are off", false);
            PedVehiclesAlso = config.GetValue<bool>("Global Settings", "Pedestrians can use popups at night", false);
            doorSpeed = config.GetValue<int>("Global Settings", "Headlights Speed for Door Headlights", 1);
            scoopSpeed = config.GetValue<int>("Global Settings", "Headlights Speed for Scoop Headlights", 55);

            ScoopUP = config.GetValue<Keys>("Keyboard Settings", "Headlights UP", Keys.ShiftKey);
            ScoopDOWN = config.GetValue<Keys>("Keyboard Settings", "Headlights DOWN", Keys.ControlKey);
            scoopSpeedKeyboard = config.GetValue<int>("Keyboard Settings", "Manual Headlights Speed", 55);
        }

        void ReadVehicles()
        {
            BackLeftDoorVehicles = File.ReadAllLines(@"scripts\PopupHeadlights\VehicleLists\BackLeftDoorVehicles.cfg").ToList();
            BackRightDoorVehicles = File.ReadAllLines(@"scripts\PopupHeadlights\VehicleLists\BackRightDoorVehicles.cfg").ToList();
            HoodDoorVehicles = File.ReadAllLines(@"scripts\PopupHeadlights\VehicleLists\HoodDoorVehicles.cfg").ToList();
            TrunkDoorVehicles = File.ReadAllLines(@"scripts\PopupHeadlights\VehicleLists\TrunkDoorVehicles.cfg").ToList();
            FrontLeftDoorVehicles = File.ReadAllLines(@"scripts\PopupHeadlights\VehicleLists\FrontLeftDoorVehicles.cfg").ToList();
            FrontRightDoorVehicles = File.ReadAllLines(@"scripts\PopupHeadlights\VehicleLists\FrontRightDoorVehicles.cfg").ToList();
            ScoopVehicles = File.ReadAllLines(@"scripts\PopupHeadlights\VehicleLists\ScoopVehicles.cfg").ToList();
        }

        void WriteTest()
        {
            File.WriteAllLines(@"scripts\PopupHeadlights\VehicleLists\BackLeftDoorVehicles.cfg", BackLeftDoorVehicles);
            File.WriteAllLines(@"scripts\PopupHeadlights\VehicleLists\BackRightDoorVehicles.cfg", BackRightDoorVehicles);
            File.WriteAllLines(@"scripts\PopupHeadlights\VehicleLists\HoodDoorVehicles.cfg", HoodDoorVehicles);
            File.WriteAllLines(@"scripts\PopupHeadlights\VehicleLists\TrunkDoorVehicles.cfg", TrunkDoorVehicles);
            File.WriteAllLines(@"scripts\PopupHeadlights\VehicleLists\FrontLeftDoorVehicles.cfg", FrontLeftDoorVehicles);
            File.WriteAllLines(@"scripts\PopupHeadlights\VehicleLists\FrontRightDoorVehicles.cfg", FrontRightDoorVehicles);
            File.WriteAllLines(@"scripts\PopupHeadlights\VehicleLists\ScoopVehicles.cfg", ScoopVehicles);
        }

        private void OnTick(object sender, EventArgs e) // This is where most of your script goes
        {

            Ped player = Game.Player.Character; // player variable
            veh = player.CurrentVehicle; // vehicle variable

            if (Function.Call<bool>(Hash.IS_PED_IN_ANY_VEHICLE, player, false))
            {
                if (PersonalVehicleSupport(veh))
                {
                    //UI.ShowSubtitle(angle.ToString() + " - " + staticAngle.ToString());
                    DoorCurrentAngle = Function.Call<float>(Hash.GET_VEHICLE_DOOR_ANGLE_RATIO, veh, DoorIndex);

                    if (lastVeh == null) { lastVeh = veh; }

                    if (!MoveDoorNOW() && !isKeyboardScoopin() && !isGamepadScoopin() && !popupsAutoUp() && !popupsAutoDown())
                    {
                        angle = DoorCurrentAngle;

                        if (lastVeh == veh)
                        {
                            if (DoorCurrentAngle > 0.05f && DoorCurrentAngle < 1.0f)
                            { Function.Call(Hash.SET_VEHICLE_DOOR_CONTROL, veh, DoorIndex, 5, staticAngle); }
                        }
                        else
                        { staticAngle = DoorCurrentAngle; Function.Call(Hash.SET_VEHICLE_DOOR_CONTROL, veh, DoorIndex, 5, staticAngle); lastVeh = veh; }
                    }

                    if (!ToggleLightsNOW() || isGamepadScoopin() && !popupsAutoUp() && !popupsAutoDown())
                    {
                        Game.DisableControl(2, GTA.Control.VehicleHeadlight);
                    }

                    if (TogglePopupTaskNOW() && Game.IsControlJustPressed(2, GTA.Control.VehicleHeadlight) && !popupsAutoUp() && !popupsAutoDown())
                    {
                        DecideIfOpenOrClose(DoorCurrentAngle);
                        doorTimer = Game.GameTime + doorSeconds;
                    }

                    if (MoveDoorNOW()) { actuallyMoveDoorsNow(); }

                    if (Game.CurrentInputMode == InputMode.GamePad)
                    {
                        if (Game.IsControlPressed(2, GTA.Control.VehicleHeadlight))
                        {
                            Game.DisableControl(2, GTA.Control.LookLeftRight);
                            Game.DisableControl(2, GTA.Control.LookUpDown);
                            if (Game.IsControlPressed(2, GTA.Control.LookUpOnly) && !popupsAutoUp() && !popupsAutoDown())
                            {
                                if (!VehHasReverseDoorLights(veh))
                                {
                                    SlowlyOpenDoor();
                                }
                                else
                                {
                                    SlowlyCloseDoor();
                                }
                            }
                            if (Game.IsControlPressed(2, GTA.Control.LookDownOnly) && !popupsAutoUp() && !popupsAutoDown())
                            {
                                if (!VehHasReverseDoorLights(veh))
                                {
                                    SlowlyCloseDoor();
                                }
                                else
                                {
                                    SlowlyOpenDoor();
                                }
                            }
                        }
                    }
                    else
                    {
                        if (!popupsAutoUp() && !popupsAutoDown())
                        {
                            if (Game.IsKeyPressed(ScoopUP))
                            {
                                if (!VehHasReverseDoorLights(veh))
                                {
                                    SlowlyOpenDoor();
                                }
                                else
                                {
                                    SlowlyCloseDoor();
                                }
                            }
                            if (Game.IsKeyPressed(ScoopDOWN))
                            {
                                if (!VehHasReverseDoorLights(veh))
                                {
                                    SlowlyCloseDoor();
                                }
                                else
                                {
                                    SlowlyOpenDoor();
                                }
                            }
                        }
                    }

                    if (popupsAutoUp())
                    {
                        if (!VehHasReverseDoorLights(veh))
                        {
                            SlowlyOpenDoor();
                        }
                        else
                        {
                            SlowlyCloseDoor();
                        }
                    }

                    if (popupsAutoDown())
                    {
                        if (!VehHasReverseDoorLights(veh))
                        {
                            SlowlyCloseDoor();
                        }
                        else
                        {
                            SlowlyOpenDoor();
                        }
                    }
                }

                if (ScoopVehicleSupport(veh))
                {
                    if (!ToggleLightsNOW())
                    {
                        Game.DisableControl(2, GTA.Control.VehicleHeadlight);
                    }

                    if (MoveScoopNOW())
                    {
                        if (scoopIsUP)
                        {
                            Function.Call<bool>(Hash._SET_CONTROL_NORMAL, 0, 60, (scoopSpeed / 100));
                        }
                        else
                        {
                            Function.Call<bool>(Hash._SET_CONTROL_NORMAL, 0, 60, -(scoopSpeed / 100));
                        }
                    }

                    if (TogglePopupTaskNOW() && Game.IsControlJustPressed(2, GTA.Control.VehicleHeadlight))
                    {
                        scoopTimer = Game.GameTime + (scoopSeconds * 1000);
                        scoopIsUP = !scoopIsUP;
                    }

                    if (Game.CurrentInputMode == InputMode.GamePad)
                    {
                        float inputPressure = Function.Call<float>(Hash.GET_CONTROL_NORMAL, 20, 8);

                        if (!MoveScoopNOW() && !popupsAutoUp())
                        {
                            if (inputPressure < 0.4f && inputPressure > -0.4f)
                            {
                                Game.DisableControl(2, GTA.Control.VehicleMoveUpDown);
                            }
                        }
                    }
                    else
                    {
                        if (!MoveScoopNOW())
                        {
                            if (!isKeyboardScoopin() && !popupsAutoUp())
                            { Game.DisableControl(2, GTA.Control.VehicleMoveUpDown); }

                            if (Game.IsKeyPressed(ScoopUP))
                            {
                                Function.Call<bool>(Hash._SET_CONTROL_NORMAL, 0, 60, -(scoopSpeedKeyboard / 100));
                            }
                            if (Game.IsKeyPressed(ScoopDOWN))
                            {
                                Function.Call<bool>(Hash._SET_CONTROL_NORMAL, 0, 60, (scoopSpeedKeyboard / 100));
                            }
                        }
                    }

                    if (popupsAutoUp()) { Function.Call<bool>(Hash._SET_CONTROL_NORMAL, 0, 60, -(scoopSpeedKeyboard / 100)); }
                }

                if (Game.IsControlJustPressed(2, GTA.Control.VehicleHeadlight) && !TogglePopupTaskNOW())
                {
                    referenceTime = Game.GameTime;
                    INISettings();
                }
            }

            if (PedVehiclesAlso)
            {
                if (IsNightTime() == true)
                {
                    allVeh = World.GetNearbyVehicles(player.Position, 30f);
                    for (int i = 0; i < allVeh.Length; i++)
                    {
                        if (allVeh[i] != veh)
                        {
                            if (allVeh[i].EngineRunning == true && allVeh[i].Driver != null)
                            {
                                CivilianVehicleSupport(allVeh[i]);
                            }
                        }
                    }
                }
            }
        }

        void SlowlyOpenDoor()
        {
            if (angle < 1.0f)
            {
                angle += (doorSpeed / 100);
                Function.Call(Hash.SET_VEHICLE_DOOR_CONTROL, veh, DoorIndex, 5, angle);
                staticAngle = angle;
            }
            else
            {
                Function.Call(Hash.SET_VEHICLE_DOOR_CONTROL, veh, DoorIndex, 5, 1.1f);
                staticAngle = 1.1f;
            }

            if (DoorCurrentAngle >= 0.95f && DoorCurrentAngle < 1.0f)
            {
                Function.Call(Hash.SET_VEHICLE_DOOR_OPEN, veh, DoorIndex, false, false);
            }
        }

        void SlowlyCloseDoor()
        {
            if (angle > 0.05f)
            {
                angle -= (doorSpeed / 100);
                Function.Call(Hash.SET_VEHICLE_DOOR_CONTROL, veh, DoorIndex, 5, angle);
                staticAngle = angle;
            }
            else
            {
                //Function.Call(Hash.SET_VEHICLE_DOOR_CONTROL, veh, DoorIndex, 5, -1f);
                staticAngle = -0.1f;
            }

            if (DoorCurrentAngle <= 0.05f && DoorCurrentAngle > 0f)
            {
                if (!isGamepadScoopin() && !isKeyboardScoopin())
                {
                    if (angle != 0.00f)
                    {
                        Function.Call(Hash.SET_VEHICLE_DOOR_SHUT, veh, DoorIndex, false);
                    }
                }
                else
                {
                    if (angle != 0.00f)
                    {
                        Function.Call(Hash.SET_VEHICLE_DOOR_SHUT, veh, DoorIndex, false);
                    }
                }
                angle = 0.0f;
            }
        }

        bool ToggleLightsNOW()
        {
            if (Game.GameTime > referenceTime + 400 && Game.GameTime < referenceTime + 800 && Game.IsControlPressed(2, GTA.Control.VehicleHeadlight))
            { return true; }
            else { return false; }
        }

        bool TogglePopupTaskNOW()
        {
            if (Game.GameTime > referenceTime + 50 && Game.GameTime < referenceTime + 400)
            { return true; }
            else { return false; }
        }

        bool MoveDoorNOW()
        {
            if (Game.GameTime < doorTimer) { return true; } else { return false; }
        }

        bool MoveScoopNOW()
        {
            if (Game.GameTime < scoopTimer) { return true; } else { return false; }
        }

        bool isKeyboardScoopin()
        {
            if (Game.IsKeyPressed(ScoopUP) || Game.IsKeyPressed(ScoopDOWN))
            { return true; }
            else { return false; }
        }

        bool isGamepadScoopin()
        {
            if (Game.CurrentInputMode == InputMode.GamePad)
            {
                if (Game.IsControlPressed(2, GTA.Control.VehicleHeadlight))
                {
                    if (Game.IsControlPressed(2, GTA.Control.LookDownOnly))
                    {
                        return true;
                    }
                    if (Game.IsControlPressed(2, GTA.Control.LookUpOnly))
                    {
                        return true;
                    }
                    return false;
                }
                return false;
            }
            return false;
        }

        void DecideIfOpenOrClose(float DoorCurrentAngle)
        {
            if (DoorCurrentAngle < 0.05f) //If door is closed, open the door.
            {
                OpenDoorNOW = true;
            }
            else
            {
                OpenDoorNOW = false;
            }
        }

        void actuallyMoveDoorsNow()
        {
            if (OpenDoorNOW)
            {
                SlowlyOpenDoor();
            }
            else
            {
                SlowlyCloseDoor();
            }
        }

        bool IsAnyLightOn()
        {
            return ((Game.Player.Character.CurrentVehicle.LightsOn == true) || (Game.Player.Character.CurrentVehicle.HighBeamsOn == true));
        }

        bool popupsAutoUp()
        {
            if (LightsAutoON && IsAnyLightOn()) { return true; } else { return false; }
        }

        bool popupsAutoDown()
        {
            if (LightsAutoOFF && !IsAnyLightOn()) { return true; } else { return false; }
        }

        bool ScoopVehicleSupport(Vehicle v)
        {
            foreach (string SCP in ScoopVehicles)
            {
                if (v.Model == SCP)
                {
                    return true;
                }
            }
            return false;
        }

        bool PersonalVehicleSupport(Vehicle v)
        {
            foreach (string BLD in BackLeftDoorVehicles)
            {
                if (v.Model == BLD)
                {
                    DoorIndex = 2;
                    return true;
                }
            }

            foreach (string HD in HoodDoorVehicles)
            {
                if (v.Model == HD)
                {
                    DoorIndex = 4;
                    return true;
                }
            }

            foreach (string BRD in BackRightDoorVehicles)
            {
                if (v.Model == BRD)
                {
                    DoorIndex = 3;
                    return true;
                }
            }

            foreach (string FLD in FrontLeftDoorVehicles)
            {
                if (v.Model == FLD)
                {
                    DoorIndex = 0;
                    return true;
                }
            }

            foreach (string FRD in FrontRightDoorVehicles)
            {
                if (v.Model == FRD)
                {
                    DoorIndex = 1;
                    return true;
                }
            }

            foreach (string TD1 in TrunkDoorVehicles)
            {
                if (v.Model == TD1)
                {
                    DoorIndex = 5;
                    return true;
                }
            }

            if (v.Model == "240sxbn")
            {
                DoorIndex = 2;
                return true;
            }

            if (v.Model == "rx7")
            {
                DoorIndex = 2;
                return true;
            }
            return false;
        }

        bool VehHasReverseDoorLights(Vehicle v)
        {
            foreach (string Rev in ReverseLightsVehicles)
            {
                if (v.Model == Rev)
                {
                    return true;
                }
            }
            return false;
        }

        public void CivilianVehicleSupport(Vehicle c)
        {
            foreach (string BLD in BackLeftDoorVehicles)
            {
                if (c.Model == BLD)
                {
                    CivHeadlights = GTA.VehicleDoor.BackLeftDoor;
                    c.OpenDoor(CivHeadlights, false, false);
                }
            }

            foreach (string HD in HoodDoorVehicles)
            {
                if (c.Model == HD)
                {
                    CivHeadlights = GTA.VehicleDoor.Hood;
                    c.OpenDoor(CivHeadlights, false, false);
                }
            }

            foreach (string BRD in BackRightDoorVehicles)
            {
                if (c.Model == BRD)
                {
                    CivHeadlights = GTA.VehicleDoor.BackRightDoor;
                    c.OpenDoor(CivHeadlights, false, false);
                }
            }

            foreach (string FLD in FrontLeftDoorVehicles)
            {
                if (c.Model == FLD)
                {
                    CivHeadlights = GTA.VehicleDoor.FrontLeftDoor;
                    c.OpenDoor(CivHeadlights, false, false);
                }
            }

            foreach (string FRD in FrontRightDoorVehicles)
            {
                if (c.Model == FRD)
                {
                    CivHeadlights = GTA.VehicleDoor.FrontRightDoor;
                    c.OpenDoor(CivHeadlights, false, false);
                }
            }

            foreach (string TD1 in TrunkDoorVehicles)
            {
                if (c.Model == TD1)
                {
                    CivHeadlights = GTA.VehicleDoor.Trunk;
                    c.OpenDoor(CivHeadlights, false, false);
                }
            }
        }

        public static bool IsNightTime() //credits to Eddlm for this method.
        {
            int hour = Function.Call<int>(Hash.GET_CLOCK_HOURS);
            return (hour > 20 || hour < 7);
        }

        void InteriorLight()
        {
            Vector3 Coords = Function.Call<Vector3>(Hash.GET_WORLD_POSITION_OF_ENTITY_BONE, Game.Player.Character.CurrentVehicle, Function.Call<int>(Hash.GET_ENTITY_BONE_INDEX_BY_NAME, Game.Player.Character.CurrentVehicle, "interiorlight"));

            UI.ShowSubtitle(Coords.ToString());

            BlockInteriorLight(Coords);
        }

        void BlockInteriorLight(Vector3 coord)
        {
            World.CreateProp(-383950123, coord, false, false);
        }
    }
}